! NAG Copyright 2017-2018.
Function scalar_pass_test(cstar, c2, c, z, cptr, r, x, i, l, cstar_to_user, &
  c4_to_user, c_to_user, z_to_user, r_to_user, x_to_user, i_to_user, &
  l_to_user, h) Result (f)
  Use, Intrinsic :: iso_c_binding
  Implicit None
  Integer, Parameter :: wp = kind(0.0D0)
  Integer :: f
  Character (*), Intent (In) :: cstar
  Character (2), Intent (In) :: c2
  Complex, Intent (In) :: c
  Complex (wp), Intent (In) :: z
  Type (c_ptr), Intent (Inout) :: cptr
  Real, Intent (In) :: r
  Real (wp), Intent (In) :: x
  Integer, Intent (In) :: i
  Logical, Intent (In) :: l
  Character (*), Intent (Out) :: cstar_to_user
  Character (4), Intent (Out) :: c4_to_user
  Complex, Intent (Out) :: c_to_user
  Complex (wp), Intent (Out) :: z_to_user
  Real, Intent (Out) :: r_to_user
  Real (wp), Intent (Out) :: x_to_user
  Integer, Intent (Out) :: i_to_user
  Logical, Intent (Out) :: l_to_user
  External :: h
  Character (3) :: h_cstar
  Character (2) :: h_c2
  Character (4) :: h_cstar_to_user
  Character (5) :: h_c5_to_user
  Complex :: h_c, h_c_to_user
  Complex (wp) :: h_z, h_z_to_user
  Type (c_ptr) :: h_cptr
  Real :: h_r, h_r_to_user
  Real (wp) :: h_x, h_x_to_user
  Integer :: h_i, h_i_to_user
  Logical :: h_l, h_l_to_user
  Character (20) :: addr
  If (cstar/='420') Stop 'FAIL char * scalar cstar'
  If (c2/='42') Stop 'FAIL char 2 scalar c2'
  If (c/=(42.,43.)) Stop 'FAIL complex64 scalar c'
  If (z/=(42._wp,43._wp)) Stop 'FAIL complex128 scalar z'
  If (.Not. c_associated(cptr)) Stop 'FAIL c_ptr scalar cptr'
  Write (addr, '(Z0)') transfer(cptr, c_intptr_t)
  If (addr/='2B') Stop 'FAIL c_ptr scalar cptr address'
  If (r/=42.) Stop 'FAIL float32 scalar r'
  If (x/=42._wp) Stop 'FAIL float64 scalar x'
  If (i/=42) Stop 'FAIL int scalar i'
  If (l) Stop 'FAIL logical scalar l'
  h_cstar_to_user = 'Hell'
  h_c5_to_user = 'World'
  h_c_to_user = (44., 45.)
  h_z_to_user = (46._wp, 47._wp)
  h_cptr = cptr
  h_r_to_user = 43.
  h_x_to_user = 43._wp
  h_i_to_user = 44
  h_l_to_user = .True.
  Call h(h_cstar, h_c2, h_c, h_z, h_cptr, h_r, h_x, h_i, h_l, h_cstar_to_user, &
    h_c5_to_user, h_c_to_user, h_z_to_user, h_r_to_user, h_x_to_user, &
    h_i_to_user, h_l_to_user)
  If (h_cstar/='420') Stop 'FAIL h char * scalar cstar'
  If (h_c2/='42') Stop 'FAIL h char 2 scalar c2'
  If (h_c/=(42.,43.)) Stop 'FAIL h complex64 scalar c'
  If (h_z/=(42._wp,43._wp)) Stop 'FAIL h complex128 scalar z'
  If (.Not. c_associated(h_cptr)) Stop 'FAIL h c_ptr scalar cptr'
  Write (addr, '(Z0)') transfer(h_cptr, c_intptr_t)
  If (addr/='2A') Stop 'FAIL h c_ptr scalar cptr address'
  If (h_r/=42.) Stop 'FAIL h float32 scalar r'
  If (h_x/=42._wp) Stop 'FAIL h float64 scalar x'
  If (h_i/=42) Stop 'FAIL h int scalar i'
  If (h_l) Stop 'FAIL h logical scalar l'
  cstar_to_user = 'Hello!'
  c4_to_user = '.rld'
  c_to_user = (46., 47.)
  z_to_user = (44._wp, 45._wp)
  cptr = h_cptr
  r_to_user = 44.
  x_to_user = 44._wp
  i_to_user = 45
  l_to_user = .True.
  f = 0
End Function
