# -*- coding: utf-8 -*-
u"""
Examples for the ``sparse`` module.

``sparse`` - Large Scale Linear Systems

This module provides functions for the solution of large sparse systems
of simultaneous linear equations.
These include iterative methods for real nonsymmetric and symmetric,
complex non-Hermitian and Hermitian linear systems and direct methods
for general real linear systems.
Further direct methods are currently available in submodule ``matop``
and submodule ``linsys``.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/f11/f11intro.html
"""

# NAG Copyright 2017-2019.

pass
